
function bandpass_filter_hw_config(this_block)
  this_block.setTopLevelLanguage('VHDL');

  this_block.setEntityName('bb_1128037332_bandpass_filter_hw');
  this_block.addSimulinkInport('gateway_in');
  this_block.port('gateway_in').useHDLVector(true);

  this_block.addSimulinkOutport('gateway_out');
  this_block.port('gateway_out').useHDLVector(true);
  this_block.port('gateway_out').setType('Fix_8_6');

  this_block.tagAsCombinational;

% -----------------------------
  % Do input type checking, and dynamic output type and 
  % generic setup here.
  if (this_block.inputTypesKnown)
    if (~ strcmp('Fix_8_6', this_block.port('gateway_in').type))
      this_block.setError('Input data type for port "gateway_in" must be "Fix_8_6".');
    end
  end

% -----------------------------

% -----------------------------
% Do input rate checking here.
  if (this_block.inputRatesKnown)
    if (this_block.port('gateway_in').rate ~= 9)
      this_block.setError('Rate for port "gateway_in" must be 9.');
    end
  end

% -----------------------------

% -----------------------------
% Set output rates here.
  this_block.port('gateway_out').setRate(9);


% -----------------------------
% Set up clocks and clock enables here.
  this_block.addClkCEPair('clk_9_sg', 'ce_9_sg', 9);
  this_block.addClkCEPair('clk_sg', 'ce_sg', 1);


% -----------------------------
% Set up vhdl/verilog files here.
  this_block.addFile('xupv2p/temp/bb_1128037332.vhd');


% -----------------------------
% Set up .edn, .mif, .coe, ... files here.
  this_block.addFile('xupv2p/temp/bandpass_filter_hw_FIR.coe');
  this_block.addFile('xupv2p/temp/bandpass_filter_hw_FIR.mif');
  this_block.addFile('xupv2p/temp/distributed_arithmetic_fir_filter_virtex2p_9_0_398549419effdecb.edn');
  this_block.addFile('xupv2p/temp/distributed_arithmetic_fir_filter_virtex2p_9_0_398549419effdecb.mif');

