
-------------------------------------------------------------------
-- System Generator version 7.1.01 VHDL source file.
--
-- Copyright(C) 2005 by Xilinx, Inc.  All rights reserved.  This
-- text/file contains proprietary, confidential information of Xilinx,
-- Inc., is distributed under license from Xilinx, Inc., and may be used,
-- copied and/or disclosed only pursuant to the terms of a valid license
-- agreement with Xilinx, Inc.  Xilinx hereby grants you a license to use
-- this text/file solely for design, simulation, implementation and
-- creation of design files limited to Xilinx devices or technologies.
-- Use with non-Xilinx devices or technologies is expressly prohibited
-- and immediately terminates your license unless covered by a separate
-- agreement.
--
-- Xilinx is providing this design, code, or information "as is" solely
-- for use in developing programs and solutions for Xilinx devices.  By
-- providing this design, code, or information as one possible
-- implementation of this feature, application or standard, Xilinx is
-- making no representation that this implementation is free from any
-- claims of infringement.  You are responsible for obtaining any rights
-- you may require for your implementation.  Xilinx expressly disclaims
-- any warranty whatsoever with respect to the adequacy of the
-- implementation, including but not limited to warranties of
-- merchantability or fitness for a particular purpose.
--
-- Xilinx products are not intended for use in life support appliances,
-- devices, or systems.  Use in such applications is expressly prohibited.
--
-- Any modifications that are made to the source code are done at the users
-- sole risk and will be unsupported.
--
-- This copyright and support notice must be retained as part of this
-- text at all times.  (c) Copyright 1995-2005 Xilinx, Inc. 
-- All rights reserved.
--------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;
use work.clock_pkg.all;

-- Generated from Simulink block "bandpass_filter_hw"

entity bandpass_filter_hw is
  port (
    ce_9_sg: in std_logic;
    ce_sg: in std_logic;
    clk_9_sg: in std_logic;
    clk_sg: in std_logic;
    gateway_in: in std_logic_vector(7 downto 0);
    gateway_out: out std_logic_vector(7 downto 0)
  );
end bandpass_filter_hw;

architecture structural of bandpass_filter_hw is
  signal ce_9_sg_x_0: std_logic;
  signal ce_sg_x_0: std_logic;
  signal clk_9_sg_x_0: std_logic;
  signal clk_sg_x_0: std_logic;
  signal convert_dout: std_logic_vector(7 downto 0);
  signal delay_q: std_logic_vector(7 downto 0);
  signal fir_dout0: std_logic_vector(21 downto 0);
  signal gateway_in_x_0: std_logic_vector(7 downto 0);
  signal sl2v_0_dout: std_logic_vector(0 downto 0);
  signal sl2v_dout: std_logic_vector(0 downto 0);

begin
  ce_9_sg_x_0 <= ce_9_sg;
  ce_sg_x_0 <= ce_sg;
  clk_9_sg_x_0 <= clk_9_sg;
  clk_sg_x_0 <= clk_sg;
  gateway_in_x_0 <= gateway_in;
  gateway_out <= delay_q;

  convert: entity work.xlconvert
    generic map (
      din_width => 22,
      din_arith => xlSigned,
      din_bin_pt => 17,
      dout_width => 8,
      dout_arith => xlSigned,
      dout_bin_pt => 6,
      bool_conversion => 0,
      latency => 0,
      overflow => xlWrap,
      quantization => xlTruncate
    )
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      din => fir_dout0,
      dout => convert_dout
    );
  delay: entity work.xldelay
    generic map (
      d_width => 8,
      d_arith => xlSigned,
      d_bin_pt => 6,
      en_width => 1,
      en_arith => xlUnsigned,
      en_bin_pt => 0,
      q_width => 8,
      q_arith => xlSigned,
      q_bin_pt => 6,
      rst_width => 1,
      rst_arith => xlUnsigned,
      rst_bin_pt => 0,
      latency => 1,
      reg_retiming => false
    )
    port map (
      ce => ce_9_sg_x_0,
      clk => clk_9_sg_x_0,
      clr => '0',
      d => convert_dout,
      en => sl2v_dout,
      rst => sl2v_0_dout,
      q => delay_q
    );
  fir: entity work.bandpass_filter_hw_fir
    generic map (
-- synopsys translate_off
      c_mem_init_file => "bandpass_filter_hw_FIR.mif",
-- synopsys translate_on
      din0_width => 8,
      din0_arith => xlSigned,
      din0_bin_pt => 6,
      dout0_width => 22,
      dout0_arith => xlSigned,
      dout0_bin_pt => 17,
      core_name0 => "distributed_arithmetic_fir_filter_virtex2p_9_0_398549419effdecb",
      c_baat => 1,
      c_channels => 1,
      c_coeff_type => 0,
      c_coeff_width => 12,
      c_data_type => 0,
      c_data_width => 8,
      c_filter_type => 0,
      c_has_sel_i => 0,
      c_has_sel_o => 0,
      c_latency => 17,
      c_polyphase_factor => 1,
      c_reg_output => 0,
      c_response => 0,
      c_result_width => 22,
      c_saturate => 0,
      c_taps => 92,
      c_use_model_func => 0,
      c_zpf => 1,
      clks_per_sample => 9,
      core_clk_at_sys_rate => 1,
      core_latency => 4,
      extra_registers => 11,
      interpolating => 0,
      latency => 14
    )
    port map (
      core_ce => ce_sg_x_0,
      core_clk => clk_sg_x_0,
      core_clr => '0',
      din0 => gateway_in_x_0,
      sample_in_ce => ce_9_sg_x_0,
      sample_in_clk => clk_9_sg_x_0,
      sample_in_clr => '0',
      sample_out_ce => ce_9_sg_x_0,
      sample_out_clk => clk_9_sg_x_0,
      sample_out_clr => '0',
      dout0 => fir_dout0
    );
  sl2v: entity work.xlsl2slv
    generic map (
      dout_width => 1,
      dout_arith => xlUnsigned,
      dout_bin_pt => 0
    )
    port map (
      din => '1',
      dout => sl2v_dout
    );
  sl2v_0: entity work.xlsl2slv
    generic map (
      dout_width => 1,
      dout_arith => xlUnsigned,
      dout_bin_pt => 0
    )
    port map (
      din => '0',
      dout => sl2v_0_dout
    );
end structural;
