
-- -----------------------------------------------------------------
-- System Generator version 7.1.01 vhdl source file.
-- 
-- Copyright(C) 2005 by Xilinx, Inc.  All rights reserved.  This
-- text/file contains proprietary, confidential information of Xilinx,
-- Inc., is distributed under license from Xilinx, Inc., and may be used,
-- copied and/or disclosed only pursuant to the terms of a valid license
-- agreement with Xilinx, Inc.  Xilinx hereby grants you a license to use
-- this text/file solely for design, simulation, implementation and
-- creation of design files limited to Xilinx devices or technologies.
-- Use with non-Xilinx devices or technologies is expressly prohibited
-- and immediately terminates your license unless covered by a separate
-- agreement.
-- 
-- Xilinx is providing this design, code, or information "as is" solely
-- for use in developing programs and solutions for Xilinx devices.  By
-- providing this design, code, or information as one possible
-- implementation of this feature, application or standard, Xilinx is
-- making no representation that this implementation is free from any
-- claims of infringement.  You are responsible for obtaining any rights
-- you may require for your implementation.  Xilinx expressly disclaims
-- any warranty whatsoever with respect to the adequacy of the
-- implementation, including but not limited to warranties of
-- merchantability or fitness for a particular purpose.
-- 
-- Xilinx products are not intended for use in life support appliances,
-- devices, or systems.  Use in such applications is expressly prohibited.
-- 
-- Any modifications that are made to source code are done at the users
-- sole risk and will be unsupported.
-- 
-- This copyright and support notice must be retained as part of this
-- text at all times.  (c) Copyright 1995-2005 Xilinx, Inc. 
-- All rights reserved.
-- -----------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;
use work.clock_pkg.all;

entity bandpass_filter_hw_clk_wrapper is 
  port (
    ce: in std_logic := '1';
    ce_clr: in std_logic := '0';
    clk: in std_logic;
    gateway_in: in std_logic_vector(7 downto 0);
    gateway_out: out std_logic_vector(7 downto 0)
  );
end bandpass_filter_hw_clk_wrapper;

architecture structural of bandpass_filter_hw_clk_wrapper is
  component bandpass_filter_hw
    port (
      ce_9_sg: in std_logic;
      ce_sg: in std_logic;
      clk_9_sg: in std_logic;
      clk_sg: in std_logic;
      gateway_in: in std_logic_vector(7 downto 0);
      gateway_out: out std_logic_vector(7 downto 0)
    );
  end component;
  component bandpass_filter_hw_clock_driver
    port (
      sysce: in std_logic;
      sysce_clr: in std_logic;
      sysclk: in std_logic;
      ce_9_sg: out std_logic;
      ce_sg: out std_logic;
      clk_9_sg: out std_logic;
      clk_sg: out std_logic
    );
  end component;
  component xlclkprobe
    port (
      ce: in std_logic;
      clk: in std_logic;
      clr: in std_logic;
      fakeoutforxst: out std_logic
    );
  end component;

  signal ce_9_sg: std_logic;
  signal ce_clr_sysgen: std_logic;
  signal ce_sg: std_logic;
  signal clk_9_sg: std_logic;
  signal clk_sg: std_logic;
  signal clk_sysgen: std_logic;
  signal gateway_in_x_0: std_logic_vector(7 downto 0);
  signal top_gateway_out: std_logic_vector(7 downto 0);

begin
  ce_clr_sysgen <= ce_clr;
  clk_sysgen <= clk;
  gateway_in_x_0 <= gateway_in;
  gateway_out <= top_gateway_out;

  clock_driver: bandpass_filter_hw_clock_driver
    port map (
      sysce => '1',
      sysce_clr => ce_clr_sysgen,
      sysclk => clk_sysgen,
      ce_9_sg => ce_9_sg,
      ce_sg => ce_sg,
      clk_9_sg => clk_9_sg,
      clk_sg => clk_sg
    );
  top: bandpass_filter_hw
    port map (
      ce_9_sg => ce_9_sg,
      ce_sg => ce_sg,
      clk_9_sg => clk_9_sg,
      clk_sg => clk_sg,
      gateway_in => gateway_in_x_0,
      gateway_out => top_gateway_out
    );
  xlclkprobe_x_0: xlclkprobe
    port map (
      ce => '1',
      clk => clk_sysgen,
      clr => '0'
    );
end structural;
