
-- -----------------------------------------------------------------
-- System Generator version 7.1.01 vhdl source file.
-- 
-- Copyright(C) 2005 by Xilinx, Inc.  All rights reserved.  This
-- text/file contains proprietary, confidential information of Xilinx,
-- Inc., is distributed under license from Xilinx, Inc., and may be used,
-- copied and/or disclosed only pursuant to the terms of a valid license
-- agreement with Xilinx, Inc.  Xilinx hereby grants you a license to use
-- this text/file solely for design, simulation, implementation and
-- creation of design files limited to Xilinx devices or technologies.
-- Use with non-Xilinx devices or technologies is expressly prohibited
-- and immediately terminates your license unless covered by a separate
-- agreement.
-- 
-- Xilinx is providing this design, code, or information "as is" solely
-- for use in developing programs and solutions for Xilinx devices.  By
-- providing this design, code, or information as one possible
-- implementation of this feature, application or standard, Xilinx is
-- making no representation that this implementation is free from any
-- claims of infringement.  You are responsible for obtaining any rights
-- you may require for your implementation.  Xilinx expressly disclaims
-- any warranty whatsoever with respect to the adequacy of the
-- implementation, including but not limited to warranties of
-- merchantability or fitness for a particular purpose.
-- 
-- Xilinx products are not intended for use in life support appliances,
-- devices, or systems.  Use in such applications is expressly prohibited.
-- 
-- Any modifications that are made to source code are done at the users
-- sole risk and will be unsupported.
-- 
-- This copyright and support notice must be retained as part of this
-- text at all times.  (c) Copyright 1995-2005 Xilinx, Inc. 
-- All rights reserved.
-- -----------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;
use work.clock_pkg.all;

entity bandpass_filter_hw_clock_driver is 
  port (
    sysce: in std_logic;
    sysce_clr: in std_logic;
    sysclk: in std_logic;
    ce_9_sg: out std_logic;
    ce_sg: out std_logic;
    clk_9_sg: out std_logic;
    clk_sg: out std_logic
  );
end bandpass_filter_hw_clock_driver;

architecture structural of bandpass_filter_hw_clock_driver is
  component xlclockdriver
    generic (
      log_2_period: integer := 4;
      period: integer := 9;
      use_bufg: integer := 0
    );
    port (
      sysce: in std_logic;
      sysclk: in std_logic;
      sysclr: in std_logic;
      ce: out std_logic;
      clk: out std_logic
    );
  end component;

  signal ce_9_sg_x_0: std_logic;
  signal ce_clr_sysgen: std_logic;
  signal ce_sg_x_0: std_logic;
  signal clk_9_sg_x_0: std_logic;
  signal clk_sg_x_0: std_logic;
  signal clk_sysgen: std_logic;

begin
  ce_clr_sysgen <= sysce_clr;
  clk_sysgen <= sysclk;
  ce_9_sg <= ce_9_sg_x_0;
  ce_sg <= ce_sg_x_0;
  clk_9_sg <= clk_9_sg_x_0;
  clk_sg <= clk_sg_x_0;

  xlclockdriver1: xlclockdriver
    generic map (
      log_2_period => 1,
      period => 1,
      use_bufg => 0
    )
    port map (
      sysce => '1',
      sysclk => clk_sysgen,
      sysclr => ce_clr_sysgen,
      ce => ce_sg_x_0,
      clk => clk_sg_x_0
    );
  xlclockdriver9: xlclockdriver
    generic map (
      log_2_period => 4,
      period => 9,
      use_bufg => 0
    )
    port map (
      sysce => '1',
      sysclk => clk_sysgen,
      sysclr => ce_clr_sysgen,
      ce => ce_9_sg_x_0,
      clk => clk_9_sg_x_0
    );
end structural;
