
-- -----------------------------------------------------------------
-- System Generator version 7.1.01 vhdl source file.
-- 
-- Copyright(C) 2005 by Xilinx, Inc.  All rights reserved.  This
-- text/file contains proprietary, confidential information of Xilinx,
-- Inc., is distributed under license from Xilinx, Inc., and may be used,
-- copied and/or disclosed only pursuant to the terms of a valid license
-- agreement with Xilinx, Inc.  Xilinx hereby grants you a license to use
-- this text/file solely for design, simulation, implementation and
-- creation of design files limited to Xilinx devices or technologies.
-- Use with non-Xilinx devices or technologies is expressly prohibited
-- and immediately terminates your license unless covered by a separate
-- agreement.
-- 
-- Xilinx is providing this design, code, or information "as is" solely
-- for use in developing programs and solutions for Xilinx devices.  By
-- providing this design, code, or information as one possible
-- implementation of this feature, application or standard, Xilinx is
-- making no representation that this implementation is free from any
-- claims of infringement.  You are responsible for obtaining any rights
-- you may require for your implementation.  Xilinx expressly disclaims
-- any warranty whatsoever with respect to the adequacy of the
-- implementation, including but not limited to warranties of
-- merchantability or fitness for a particular purpose.
-- 
-- Xilinx products are not intended for use in life support appliances,
-- devices, or systems.  Use in such applications is expressly prohibited.
-- 
-- Any modifications that are made to source code are done at the users
-- sole risk and will be unsupported.
-- 
-- This copyright and support notice must be retained as part of this
-- text at all times.  (c) Copyright 1995-2005 Xilinx, Inc. 
-- All rights reserved.
-- -----------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;
use work.clock_pkg.all;

entity bandpass_filter_hw_dcm_wrapper is 
  port (
    ce_clr: in std_logic := '0';
    clk: in std_logic;
    gateway_in: in std_logic_vector(7 downto 0);
    rst: in std_logic;
    gateway_out: out std_logic_vector(7 downto 0)
  );
end bandpass_filter_hw_dcm_wrapper;

architecture structural of bandpass_filter_hw_dcm_wrapper is
  component bandpass_filter_hw_clk_wrapper
    port (
      ce: in std_logic := '1';
      ce_clr: in std_logic := '0';
      clk: in std_logic;
      gateway_in: in std_logic_vector(7 downto 0);
      gateway_out: out std_logic_vector(7 downto 0)
    );
  end component;
  component xlclockgenerator
    generic (
      ensure_clks_stable: boolean := false
    );
    port (
      clk: in std_logic;
      rst: in std_logic;
      clk0: out std_logic
    );
  end component;

  signal bandpass_filter_hw_clock_wrapper_gateway_out: std_logic_vector(7 downto 0);
  signal ce_clr_x_0: std_logic;
  signal clk_0: std_logic;
  signal clk_src: std_logic;
  signal gateway_in_x_0: std_logic_vector(7 downto 0);
  signal rst_x_0: std_logic;

begin
  ce_clr_x_0 <= ce_clr;
  clk_src <= clk;
  gateway_in_x_0 <= gateway_in;
  rst_x_0 <= rst;
  gateway_out <= bandpass_filter_hw_clock_wrapper_gateway_out;

  bandpass_filter_hw_clock_generator: xlclockgenerator
    generic map (
      ensure_clks_stable => false
    )
    port map (
      clk => clk_src,
      rst => rst_x_0,
      clk0 => clk_0
    );
  bandpass_filter_hw_clock_wrapper: bandpass_filter_hw_clk_wrapper
    port map (
      ce_clr => ce_clr_x_0,
      clk => clk_0,
      gateway_in => gateway_in_x_0,
      gateway_out => bandpass_filter_hw_clock_wrapper_gateway_out
    );
end structural;
