
-------------------------------------------------------------------
-- System Generator version 7.1.01 VHDL source file.
--
-- Copyright(C) 2005 by Xilinx, Inc.  All rights reserved.  This
-- text/file contains proprietary, confidential information of Xilinx,
-- Inc., is distributed under license from Xilinx, Inc., and may be used,
-- copied and/or disclosed only pursuant to the terms of a valid license
-- agreement with Xilinx, Inc.  Xilinx hereby grants you a license to use
-- this text/file solely for design, simulation, implementation and
-- creation of design files limited to Xilinx devices or technologies.
-- Use with non-Xilinx devices or technologies is expressly prohibited
-- and immediately terminates your license unless covered by a separate
-- agreement.
--
-- Xilinx is providing this design, code, or information "as is" solely
-- for use in developing programs and solutions for Xilinx devices.  By
-- providing this design, code, or information as one possible
-- implementation of this feature, application or standard, Xilinx is
-- making no representation that this implementation is free from any
-- claims of infringement.  You are responsible for obtaining any rights
-- you may require for your implementation.  Xilinx expressly disclaims
-- any warranty whatsoever with respect to the adequacy of the
-- implementation, including but not limited to warranties of
-- merchantability or fitness for a particular purpose.
--
-- Xilinx products are not intended for use in life support appliances,
-- devices, or systems.  Use in such applications is expressly prohibited.
--
-- Any modifications that are made to the source code are done at the user's
-- sole risk and will be unsupported.
--
-- This copyright and support notice must be retained as part of this
-- text at all times.  (c) Copyright 1995-2005 Xilinx, Inc.  All rights
-- reserved.
-------------------------------------------------------------------
library IEEE;
-- synopsys translate_off
library XilinxCoreLib;
-- synopsys translate_on
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;
-- synopsys translate_off
library unisim;
use unisim.vcomponents.all;
-- synopsys translate_on
entity bandpass_filter_hw_fir is
  generic (
    core_name0: string := "";
    din0_width: integer := 8;
    din0_bin_pt: integer := 2;
    din0_arith: integer := xlSigned;
    dout0_width: integer := 18;
    dout0_bin_pt: integer := 8;
    dout0_arith: integer := xlSigned;
    vin_width: integer := 1;
    vin_bin_pt: integer := 0;
    vin_arith: integer := xlUnsigned;
    vout_width: integer := 1;
    vout_bin_pt: integer := 0;
    vout_arith: integer := xlUnsigned;
    c_data_width: integer := 8;
    c_result_width: integer := 18;
    c_coeff_width: integer := 8;
    c_taps: integer := 2;
    c_response: integer := 1;
    c_data_type: integer := 0;
    c_coeff_type: integer := 8;
    c_channels: integer := 1;
    c_filter_type: integer := 0;
    c_saturate: integer := 0;
    c_has_sel_o: integer := 0;
    c_has_sel_i: integer := 0;
                -- synopsys translate_off
    c_mem_init_file: string := "null.mif";
                -- synopsys translate_on
    uid: integer := 0;
    c_zpf: integer := 1;
    c_polyphase_factor: integer := 1;
    c_reg_output: integer := 1;
    c_baat: integer := 8;
    c_use_model_func: integer := 0;
    c_latency: integer := 6;
    core_clk_at_sys_rate: integer := 0;
    clks_per_sample: integer := 1;
    latency: integer := 1;
    core_latency: integer := 1;
    interpolating: integer := 1;
    extra_registers: integer := 0
  );
  port (
    din0: in std_logic_vector(din0_width - 1 downto 0);
    vin: in std_logic_vector(0 downto 0) := "1";
    sample_in_ce: in std_logic;
    sample_in_clr: in std_logic;
    sample_in_clk: in std_logic;
    core_ce: in std_logic;
    core_clr: in std_logic;
    core_clk: in std_logic;
    sample_out_ce: in std_logic;
    sample_out_clr: in std_logic;
    sample_out_clk: in std_logic;
    dout0: out std_logic_vector(dout0_width - 1 downto 0);
    vout: out std_logic_vector(vout_width - 1 downto 0)
  );
end bandpass_filter_hw_fir;
architecture behavior of bandpass_filter_hw_fir is
  component synth_reg
    generic (
      width: integer := 16;
      latency: integer := 5
    );
    port (
      i: in std_logic_vector(width - 1 downto 0);
      ce: in std_logic;
      clr: in std_logic;
      clk: in std_logic;
      o: out std_logic_vector(width - 1 downto 0)
    );
  end component;
  component synth_reg_w_init
    generic (
      width: integer := 16;
      init_index: integer := 0;
      latency: integer := 5
    );
    port (
      i: in std_logic_vector(width - 1 downto 0);
      ce: in std_logic;
      clr: in std_logic;
      clk: in std_logic;
      o: out std_logic_vector(width - 1 downto 0)
    );
  end component;
  component fds
    port (
      q: out std_ulogic;
      d: in std_ulogic;
      c: in std_ulogic;
      s: in std_ulogic
    );
  end component;
  attribute syn_black_box of fds: component is true;
  attribute fpga_dont_touch of fds: component is "true";
  component sync_fifo
    generic (
      din_width: integer := 8;
      din_bin_pt: integer := 2;
      din_arith: integer := xlSigned;
      dout_width: integer := 18;
      dout_bin_pt: integer := 8;
      dout_arith: integer := xlSigned;
      depth: integer := 3
    );
    port (
      din: in std_logic_vector(din_width - 1 downto 0);
      write_ce: in std_logic;
      read_ce: in std_logic;
      clr: in std_logic;
      clk: in std_logic;
      dout: out std_logic_vector(dout_width - 1 downto 0)
    );
  end component;
  signal nd: std_logic;
  signal rfd: std_logic;
  signal core_rdy: std_logic;
  signal registered_rdy: std_logic;
  signal sampled_dout0: std_logic_vector(c_result_width-1 downto 0) :=
    (others => '0');
  signal raw_dout0: std_logic_vector(c_result_width - 1 downto 0);
  signal core_dout0: std_logic_vector(c_result_width - 1 downto 0);
  signal registered_dout0: std_logic_vector(c_result_width - 1 downto 0) :=
    (others => '0');
  signal del_sample_in_ce: std_logic;
  signal clr_pulse, fifo_clr: std_logic;

  -- synopsys translate_off
  signal real_din0, real_core_dout0, real_sampled_dout0,
    real_sampled_dout0_dly, real_dout0: real;
  -- synopsys translate_on
  component distributed_arithmetic_fir_filter_virtex2p_9_0_398549419effdecb
    port (
      nd: in std_logic;
      rdy: out std_logic;
      clk: in std_logic;
      rfd: out std_logic;
      din: in std_logic_vector(c_data_width - 1 downto 0);
      dout: out std_logic_vector(c_result_width - 1 downto 0)
    );
  end component;
  attribute syn_black_box of distributed_arithmetic_fir_filter_virtex2p_9_0_398549419effdecb: component is true;
  attribute fpga_dont_touch of distributed_arithmetic_fir_filter_virtex2p_9_0_398549419effdecb: component is "true";
begin
  -- synopsys translate_off
  -- synopsys translate_on
  sample_in_ce_reg: fds
    port map (
      q => del_sample_in_ce,
      d => sample_in_ce,
      c => core_clk,
      s => core_clr
    );
  nd <= vin(0) and del_sample_in_ce;
  comp0: if (not simulating and
             (core_name0 = "distributed_arithmetic_fir_filter_virtex2p_9_0_398549419effdecb")) generate
    core_instance0: distributed_arithmetic_fir_filter_virtex2p_9_0_398549419effdecb
      port map (
        nd => nd,
        rdy => core_rdy,
        clk => core_clk,
        rfd => rfd,
        din => din0,
        dout => core_dout0
      );
  end generate;
-- synopsys translate_off
  comp1: if (simulating and
             (core_name0 = "distributed_arithmetic_fir_filter_virtex2p_9_0_398549419effdecb")) generate
    core_instance1: entity XilinxCoreLib.c_da_fir_v9_0(behavioral)
      generic map (
        c_baat => c_baat,
        c_has_sin_f => 0,
        c_channels => c_channels,
        c_has_sel_o => c_has_sel_o,
        c_reload_delay => 0,
        c_reload_mem_type => 1,
        c_filter_type => c_filter_type,
        c_has_sel_i => c_has_sel_i,
        c_shape => 0,
        c_coeff_type => c_coeff_type,
        c_taps => c_taps,
        c_has_sout_r => 0,
        c_zpf => c_zpf,
        c_polyphase_factor => c_polyphase_factor,
        c_data_width => c_data_width,
        c_has_sout_f => 0,
        c_optimize => 1,
        c_use_model_func => c_use_model_func,
        c_data_type => c_data_type,
        c_latency => c_latency,
        c_coeff_width => c_coeff_width,
        c_has_reset => 0,
        c_reload => 0,
        c_result_width => c_result_width,
        c_saturate => c_saturate,
        c_mem_init_file => c_mem_init_file,
        c_reg_output => c_reg_output,
        c_has_sin_r => 0,
        c_enable_rlocs => 0,
        c_response => c_response
      )
      port map (
        nd => nd,
        rdy => core_rdy,
        clk => core_clk,
        rfd => rfd,
        din => din0,
        dout => core_dout0
      );
  end generate;
-- synopsys translate_on
  reg_core_output: process (core_clk, core_clr)
  begin
    if core_clr = '1' then
      registered_dout0 <= (others => '0');
    elsif core_clk'event and core_clk = '1' then
      if core_rdy = '1' then
        registered_dout0 <= core_dout0;
      end if;
      registered_rdy <= core_rdy;
    end if;
  end process;
  valid_pipe: synth_reg_w_init
    generic map (
      width => 1,
      init_index => 0,
      latency => latency
    )
    port map (
      i => vin,
      ce => sample_out_ce,
      clr => sample_out_clr,
      clk => core_clk,
      o => vout
    );
  polyphase_eq_1: if not((interpolating = 1) and (c_polyphase_factor > 1))
  generate
    sample_output: process (core_clk)
    begin
      if core_clk'event and core_clk = '1' then
        if sample_out_ce = '1' then
          sampled_dout0 <= registered_dout0;
        end if;
      end if;
    end process;
  end generate;
  polyphase_gt_1: if (interpolating = 1) and (c_polyphase_factor > 1)
  generate
   fifo_clr_ff: fds
    port map (
      q => clr_pulse,
      d => '0',
      c => core_clk,
      s => core_clr
    );
    fifo_clr <= clr_pulse or sample_out_clr;

    sync_fifo_comp: sync_fifo
      generic map (
        din_width => c_result_width,
        din_bin_pt => dout0_bin_pt,
        din_arith => dout0_arith,
        dout_width => c_result_width,
        dout_bin_pt => dout0_bin_pt,
        depth => c_polyphase_factor
      )
      port map (
        din => registered_dout0,
        write_ce => registered_rdy,
        read_ce => sample_out_ce,
        clr => fifo_clr,
        clk => core_clk,
        dout => sampled_dout0
      );
  end generate;
  latency_test: if (extra_registers > 0)
  generate
    reg: synth_reg
      generic map (
        width => c_result_width,
        latency => extra_registers
      )
      port map (
        i => sampled_dout0,
        ce => sample_out_ce,
        clr => sample_out_clr,
        clk => core_clk,
        o => raw_dout0
      );
  end generate;
  latency0: if ((latency = 0) or (extra_registers = 0))
  generate
    raw_dout0 <= sampled_dout0;
  end generate;
  sign_extend: process (raw_dout0)
  begin
    if dout0_arith = xlUnsigned then
      dout0 <= zero_ext(raw_dout0, dout0_width);
    else
      dout0 <= sign_ext(raw_dout0, dout0_width);
    end if;
  end process;
end architecture behavior;
