%
% Filename:    xup_virtex_ii_pro_target.m
%
% Description: This file defines the supported and default compilation
%              settings for the XUP Virtex-II Pro
%

function settings = xup_virtex_ii_pro_target

  % Define parts supported by the target.
  part0.('family') = 'virtex2p';
  part0.('part') = 'xc2vp30';
  part0.('speed') = '-7';
  part0.('package') = 'ff896';
  settings.('supported_parts').('allowed') = {part0};

  % Target has a fixed, free-running clock period.
  settings.('sysclk_period').('allowed') = '10';

  % Define post-generation callback function.
  settings.('postgeneration_fcn') = 'xup_virtex_ii_pro_postgeneration';

  % Testbench should not be generated for this target.
  settings.('testbench').('allowed') = 'off';

  % Set default target directory for this target.
  settings.('directory') = './netlist';

  % List supported synthesis tools.
  settings.('synthesis_tool') = 'XST';

  % Define pre-compile callback function.
  settings.('precompile_fcn') = 'xlJTAGPreCompile';

  % Define post-generation callback function.
  settings.('getimportblock_fcn') = 'xlGetHwcosimBlockName';

  % Disable the clock location constraint field.
  settings.('clock_loc').('allowed') = 'Fixed';

  % Define a hardware co-simulation settings GUI.
  settings.('settings_fcn') = 'xlJTAGXFlowSettings';
